Hardware Locality (hwloc): Topology Object Types

Hardware Locality (hwloc) 1.2.2

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Enumerations | Functions
Topology Object Types

## Enumerations
enum | hwloc_obj_type_t { HWLOC_OBJ_SYSTEM, HWLOC_OBJ_MACHINE, HWLOC_OBJ_NODE, HWLOC_OBJ_SOCKET, HWLOC_OBJ_CACHE, HWLOC_OBJ_CORE, HWLOC_OBJ_PU, HWLOC_OBJ_GROUP, HWLOC_OBJ_MISC, HWLOC_OBJ_TYPE_MAX }
enum | hwloc_compare_types_e { HWLOC_TYPE_UNORDERED }
## Functions
int | hwloc_compare_types (hwloc_obj_type_t type1, hwloc_obj_type_t type2)

## Enumeration Type Documentation

enum hwloc_compare_types_e

Enumerator:

  HWLOC_TYPE_UNORDERED | Value returned by hwloc_compare_types when types can not be compared.

enum hwloc_obj_type_t

Type of topology object.

Note:
  Do not rely on the ordering or completeness of the values as new ones may be defined in the future! If you need to compare types, use hwloc_compare_types() instead.

Enumerator:

  HWLOC_OBJ_SYSTEM | Whole system (may be a cluster of machines). The whole system that is accessible to hwloc. That may comprise several machines in SSI systems like Kerrighed.
  HWLOC_OBJ_MACHINE | Machine. The typical root object type. A set of processors and memory with cache coherency.
  HWLOC_OBJ_NODE | NUMA node. A set of processors around memory which the processors can directly access.
  HWLOC_OBJ_SOCKET | Socket, physical package, or chip. In the physical meaning, i.e. that you can add or remove physically.
  HWLOC_OBJ_CACHE | Data cache. Can be L1, L2, L3, ...
  HWLOC_OBJ_CORE | Core. A computation unit (may be shared by several logical processors).
  HWLOC_OBJ_PU | Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical processors, e.g. in the case of an SMT core). Objects of this kind are always reported and can thus be used as fallback when others are not.
  HWLOC_OBJ_GROUP | Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take into account for affinity. For instance, some operating systems expose their arbitrary processors aggregation this way. And hwloc may insert such objects to group NUMA nodes according to their distances. These objects are ignored when they do not bring any structure.
  HWLOC_OBJ_MISC | Miscellaneous objects. Objects without particular meaning, that can e.g. be added by the application for its own use.
  HWLOC_OBJ_TYPE_MAX | Sentinel value

## Function Documentation

int hwloc_compare_types | ( | hwloc_obj_type_t | type1,
|  | hwloc_obj_type_t | type2
| ) |  | const

Compare the depth of two object types.

Types shouldn't be compared as they are, since newer ones may be added in the future. This function returns less than, equal to, or greater than zero respectively if `type1` objects usually include `type2` objects, are the same as `type2` objects, or are included in `type2` objects. If the types can not be compared (because neither is usually contained in the other), HWLOC_TYPE_UNORDERED is returned. Object types containing CPUs can always be compared (usually, a system contains machines which contain nodes which contain sockets which contain caches, which contain cores, which contain processors).

Note:
  HWLOC_OBJ_PU will always be the deepest.
  This does not mean that the actual topology will respect that order: e.g. as of today cores may also contain caches, and sockets may also contain nodes. This is thus just to be seen as a fallback comparison method.